<template>
  <div id="teacher_class_manage_enrollment_wrapper">
    <!-- <el-breadcrumb class="page-title" separator="|">
      <el-breadcrumb-item :to="{ path: '/a/teacher/class/manage' }">{{ $t('TEACHER_CLASS.MANAGE_COURSE') }}</el-breadcrumb-item>
      <el-breadcrumb-item>{{ $t('TEACHER_CLASS.MNG_STUD') }}</el-breadcrumb-item>
      <a href="javascript:history.back();">
        <el-button size="small" style="float: right; margin-right: 15px;">{{ $t('BOARD.BACK') }}</el-button>
      </a>
    </el-breadcrumb> -->

    <el-tabs type="border-card" v-model="activeTab" :before-leave="beforeLeaveTab" class="setting-tabs">
      <el-tab-pane :label="$t('TEACHER_CLASS.BASIC_SETTING')" name="basic">
        <enrollment-basic-setting
          :classId="classId">
        </enrollment-basic-setting>
      </el-tab-pane>
      <el-tab-pane :label="$t('TEACHER_CLASS.ENROLL_LIST')" name="waiting">
        <enrollment-waiting-list
          :classId="classId"
          :waitingList="waitingList"
          :refreshDisable="refreshDisable"
          :refreshCountDown="refreshCountDown"
          @refreshWaitingList="refreshWaitingList"
          @refreshAllList="refreshAllList">
        </enrollment-waiting-list>
      </el-tab-pane>
      <el-tab-pane :label="$t('TEACHER_CLASS.STUDENT_LIST')" name="finish">
        <enrollment-finish-list
          :classId="classId"
          :finishList="finishList"
          :refreshDisable="refreshDisable"
          :refreshCountDown="refreshCountDown"
          @refreshFinishList="refreshFinishList"
          @refreshAllList="refreshAllList">
        </enrollment-finish-list>
      </el-tab-pane>
    </el-tabs>
  </div>
</template>

<script>
import EnrollmentBasicSetting from '../partials/EnrollmentBasicSetting';
import EnrollmentWaitingList from '../partials/EnrollmentWaitingList';
import EnrollmentFinishList from '../partials/EnrollmentFinishList';
import enrollmentService from '../../services/enrollmentService';
import classService from '../../services/classService';
import userService from '../../services/userService';

export default {
  name: 'TeacherClassManageEnrollment',
  data() {
    return {
      activeTab: 'basic',
      waitingList: [],
      finishList: [],
      refreshDisable: false,
      refreshCountDown: 0,
    };
  },
  props: {
    classId: {
      type: Number,
      default: null
    }
  },
  methods: {
    async beforeLeaveTab() {
      const vm = this;
      await vm.refreshAllList();
      return true;
    },
    async refreshAllList () {
      const vm = this;
      vm.refreshDisable = true;
      vm.refreshCountDown = 3;
      setTimeout(() => {
        vm.refreshDisable = false;
      }, 3000);
      setTimeout(() => {
        vm.refreshCountDown -= 1;
      }, 1000);
      setTimeout(() => {
        vm.refreshCountDown -= 1;
      }, 2000);
      setTimeout(() => {
        vm.refreshCountDown -= 1;
      }, 3000);
      await vm.refreshWaitingList();
      await vm.refreshFinishList();
    },
    async refreshWaitingList () {
      const vm = this;
      const waitList = await enrollmentService.getEnrollmentByClassId({
        class_id: vm.classId,
      })
      vm.waitingList = [];
      waitList.data.enrollData.forEach((data) => {
        if (!isNaN(Date.parse(data.created_at))) {
          data.created_at = new Date(Date.parse(data.created_at)).toLocaleString();
        }
        vm.waitingList.push(data);
      });
    },
    async refreshFinishList () {
      const vm = this;
      const finishList = await userService.getUserClassesByClassId({
        classId: vm.classId,
      });
      vm.finishList = [];
      try {
        finishList.data.user_classes.forEach((userData) => {
          userData.user.enrollments = userData.user.enrollments.length > 0 ? userData.user.enrollments[userData.user.enrollments.length - 1] : null;
          if (userData.user.enrollments !== null) {
            userData.user.enrollments.updated_at = new Date(userData.user.enrollments.updated_at).toLocaleString();
          }
          vm.finishList.push(userData.user);
        });
      } catch (err) {
        // FIXME: user.enrollments 없는 경우 무한 루프 발생 (레거시 코드 관련)
        setTimeout(() => {
          vm.refreshFinishList();
        }, 100);
      }
    },
  },
  components: {
    EnrollmentBasicSetting,
    EnrollmentWaitingList,
    EnrollmentFinishList,
  },
  async mounted() {
    const vm = this;
    await vm.refreshWaitingList();
  },
  // computed: {
  //   classId() {
  //     const vm = this;

  //     return Number.parseInt(vm.$route.params.classId, 10);
  //   },
  // }
};
</script>

<style lang="scss" scoped>
#teacher_class_manage_enrollment_wrapper {
  .page-title {
    width: 100%;
    height: 24px;
    font-family: SpoqaHanSans;
    font-size: 25px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.2;
    letter-spacing: normal;
    color: #000000;

    margin-top : 40px;
    margin-left : 12px;
    margin-bottom : 40px;
  }
  
  .setting-tabs {
  }
}
</style>